package bst;

import list.List;

public class SymbolTable {

    public TreeSet<Symbol> symbols;
    public record Symbol(String name, String type) implements Comparable<Symbol> {
        @Override
        public int compareTo(Symbol other) {
            return this.name.compareTo(other.name);
        }
    }

    public SymbolTable() {
        symbols = new TreeSet<>();
    }

    public boolean add(String name, String type) {
        if (!symbols.add(new Symbol(name, type))) {
            throw new IllegalArgumentException("Symbol already exists in the table.");
        }
        return true;
    }

    public boolean contains(String name, String type) {
        return symbols.contains(new Symbol(name, type));
    }

    public boolean remove(String name, String type) {
        if (!symbols.remove(new Symbol(name, type))) {
            throw new IllegalArgumentException("Symbol does not exist in the table.");
        }
        return true;
    }

}
