package bst;

public class TreeMap<K, V>{

    private IBinarySearchTree<Entry> bst;

    public TreeMap() {
        bst = new BinarySearchTree<>();
    }

    public boolean containsKey(K key) {
        return bst.contains(new Entry(key, null));
    }

    public V get(K key) {
        Entry e = new Entry(key, null);
        V toReturn = null;
        Entry theEntry = bst.find(e);
        if (theEntry != null) {
            toReturn = theEntry.getValue();
        }
        return toReturn;
    }

    public V remove(Object o) {
        Entry e = new Entry((K) o, null);
        V toReturn = null;
        Entry theEntry = bst.find(e);
        if (theEntry != null) {
            toReturn = theEntry.getValue();
            bst.remove(e);
        }
        return toReturn;
    }

    public V put(K key, V value) {
        Entry e = new Entry(key, value);
        V toReturn = null;
        Entry theEntry = bst.find(e);
        if (theEntry != null) {
            toReturn = theEntry.getValue();
            theEntry.setValue(value);
        } else {
            bst.add(e);
        }
        return toReturn;
    }




    private class Entry implements Comparable<Entry> {
        K key;
        V value;

        public int compareTo(Entry other) {
            Comparable<K> comparableKey = (Comparable<K>) this.key;
            return comparableKey.compareTo(other.key);
        }

        public K getKey() {
            return key;
        }

        public V getValue() {
            return value;
        }

        public void setValue(V value) {
            this.value = value;
        }

        public Entry(K key, V value) {
            this.key = key;
            this.value = value;
        }
    }
}
